>module PrettyP (PpShow(..), pp, module Pretty, render,enclose) where

>import Pretty hiding (render)
>import qualified Pretty (render)
>import Char (showLitChar)
>render :: Doc -> String
>render = Pretty.render

>enclose :: PpShow a => a -> Doc
>enclose x = pp "'" <> pp x <> pp "'"

>class PpShow a where
>      pp :: a -> Doc

>instance PpShow a => PpShow [a] where
>	  pp x = pp '[' <> fsep (punctuate (pp ';') (map pp x)) <> pp ']'

>instance PpShow IOError where
>	  pp x = pp (show x)

>instance PpShow () where
>	  pp _ = pp "()"

>instance PpShow Doc where
>	  pp x = x

>instance PpShow String where
>	  pp = ptext

>instance PpShow Bool where
>         pp True = pp "True"
>         pp False = pp "False"

>instance PpShow Char where
>	  pp c = pp (showLitChar c "")-- char

>instance PpShow Int where
>	  pp = int

>instance PpShow Integer where
>	  pp = integer

>instance PpShow Float where
>	  pp = float

>instance PpShow Double where
>	  pp = double

>instance (PpShow a, PpShow b) => PpShow (a,b) where
>	  pp (x,y) = fsep [pp '(' <> pp x <> pp ',', nest 4 $ pp y <> pp ')']
>instance (PpShow a, PpShow b, PpShow c) => PpShow (a,b,c) where
>	  pp (x,y,z) = fsep [pp '(' <> pp x <> pp ',', nest 4 $ pp y <> pp ',', nest 4 $ pp z <> pp ')']
>instance (PpShow a, PpShow b, PpShow c,PpShow d) => PpShow (a,b,c,d) where
>	  pp (x,y,z,z') = fsep [pp '(' <> pp x <> pp ',', nest 4 $ pp y <> pp ',',
>					  nest 4 $ pp z <> pp ',', nest 4 $ pp z' <> pp ')']

>instance PpShow a => PpShow (Maybe a) where
>	  pp Nothing = pp "Nothing"
>	  pp (Just x) = pp x

>instance (PpShow a, PpShow b) => PpShow (Either a b) where
>	  pp (Left x) = pp "Left(" <> pp x <> pp ")"
>	  pp (Right x) = pp "Right("<> pp x <> pp ")"